package dev.fyloz.trial.colorrecipesexplorer.core.services;

import dev.fyloz.trial.colorrecipesexplorer.core.model.Mix;
import dev.fyloz.trial.colorrecipesexplorer.core.services.model.MaterialService;
import dev.fyloz.trial.colorrecipesexplorer.core.model.Recipe;
import dev.fyloz.trial.colorrecipesexplorer.core.services.model.MixQuantityService;
import dev.fyloz.trial.colorrecipesexplorer.core.services.model.MixService;
import org.junit.Before;
import org.mockito.InjectMocks;
import org.mockito.Mock;
import org.mockito.MockitoAnnotations;
import org.mockito.Spy;

import static org.mockito.ArgumentMatchers.any;

public class MixServiceTests {

    @Mock
    private MaterialService materialService;

    @Mock
    private MixQuantityService mixQuantityService;

    @Spy
    @InjectMocks
    private MixService mixService;

    private Mix testMix;

    @Before
    public void init() {
        MockitoAnnotations.initMocks(this);

        Recipe recipe = new Recipe();
        recipe.setRecipeId(0);
        recipe.setName("Test Recipe");

        testMix = new Mix();
        testMix.setMixId(0);
        testMix.setRecipe(recipe);
    }

//    @Test
//    public void createTest() {
//        List<Integer> materials = new ArrayList<>();
//        materials.add(0);
//        List<Float> quantities = new ArrayList<>();
//        List<MixQuantity> mquantities = new ArrayList<>();
//        mquantities.add(new MixQuantity());
//        quantities.add(1000f);
//        MixType type = new MixType();
//        type.setName("Test Type");
//
//        doReturn(Optional.of(testMix)).when(mixService).save(any());
//        doReturn(mquantities).when(mixService).createMixQuantities(any(), any(), any());
//        ModelResponseBuilder fakeResponseBuilder = mock(ModelResponseBuilder.class);
//        verify(fakeResponseBuilder, times(0)).addResponseCode(any());
//
//        mixService.create(new ModelResponseBuilder(""), materials, quantities, testMix.getRecipe(), type);
//    }

//    @Test
//    public void createTestMaterialNotFound() {
//        List<Integer> materials = new ArrayList<>();
//        materials.add(0);
//        List<Float> quantities = new ArrayList<>();
//        List<MixQuantity> mquantities = new ArrayList<>();
//        mquantities.add(new MixQuantity());
//        quantities.add(1000f);
//        MixType type = new MixType();
//        type.setName("Test Type");
//
//        doReturn(Optional.of(testMix)).when(mixService).save(any());
//        doReturn(mquantities).when(mixService).createMixQuantities(any(), any(), any());
//        ModelResponseBuilder fakeResponseBuilder = mock(ModelResponseBuilder.class);
//        verify(fakeResponseBuilder, times(0)).addResponseCode(any());
//
//        mixService.create(new ModelResponseBuilder(""), materials, quantities, testMix.getRecipe(), type);
//    }

}
