package dev.fyloz.trial.colorrecipesexplorer.dao;

import dev.fyloz.trial.colorrecipesexplorer.core.model.MaterialType;
import org.springframework.data.jpa.repository.JpaRepository;

import java.util.Optional;

public interface MaterialTypeDao extends JpaRepository<MaterialType, Long> {

    Optional<MaterialType> findByName(String name);

    Optional<MaterialType> findByPrefix(String prefix);

}
